#include <bits/stdc++.h>
#define pb push_back
using namespace std;
vector<int> v[100005];
vector<int> p;
int used[100005];
int f = 1, k = 0, n, m;
void dfs(int s) {
    used[s]++;
    k++;
    if (k == n) {
        for (int i = 0; i < v[s].size(); i++) {
            if (v[s][i] == 1) {
                p.pb(1);
                cout << "YES\n";
                f = 0;
            }
        }
    }
    else {
        for (int i = 0; i < v[s].size(); i++) {
            int h = v[s][i];
            if (used[h] == 0) {
                dfs(h);
            }
        }
    }
    p.pb(s);
    
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
	cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        v[a].pb(b);
    }
    dfs(1);
    if (f == 0) {
        cout << "NO";
    }
    else {
        cout << "1 ";
        for (auto i : p) {
            cout << i << " ";
        }
    }
}
